<?php
/*
Plugin Name: Easy Image Widget
Plugin URI: http://racase.com/blog/easy-image-widget
Description: A simple WordPress plugin to add image in sidebars.
Version: 1.1
Author: Racase Lawaju
Text Domain: easy-image-widget
Author URI: http://www.racase.com
License: GPL2
*/
/*
Copyright 2014  Racase Lawaju  (email : arryaas@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#Define
define( 'SIW_VER',1.1);
define( 'SIW_DOMAIN','easy-image-widget');
define( 'SIW_NAME', 'Easy Image Widget' );
define( 'SIW_DESC', 'A simple WordPress plugin to add image in sidebars.' );

#Load Widget Class
include_once(sprintf("%s/widget.php",dirname(__FILE__)));

# Check if class already exits
if(!class_exists("easy_image_widget")){
	/**
	* Class : easy_image_widget
	*/
	class easy_image_widget
	{

		public function __construct()
		{
			
			add_action( 'widgets_init', array( &$this, 'load_widget' ) );
			add_action( 'admin_enqueue_scripts', array( &$this, 'load_admin_style' ) );
			add_action( 'plugins_loaded', array( &$this, 'load_textdomain' ) );

		} # END Function : __construct

		function load_admin_style( $hook ) {

			if( 'widgets.php' != $hook )
				return;

			wp_enqueue_media();

        	// wp_register_style( 'tipr-style', plugin_dir_url( __FILE__ ) . 'css/tipr.css', false, SIW_VER );
        	// wp_enqueue_style( 'tipr-style' );
        	wp_register_style( 'SIW-style', plugin_dir_url( __FILE__ ) . 'css/SIW.css', false, SIW_VER );
        	wp_enqueue_style( 'SIW-style' );
        	// wp_enqueue_script( 'tipr-script', plugin_dir_url( __FILE__ ) . 'js/tipr.min.js', false, SIW_VER );
        	wp_enqueue_script( 'SIW-script', plugin_dir_url( __FILE__ ) . 'js/SIW.js', false, SIW_VER );

		}


		/*
		* Register and load the widget
		*/
		function load_widget() {
			register_widget( 'SIW_widget' );
		}

		function load_textdomain() {
			load_plugin_textdomain( SIW_DOMAIN, false, dirname( plugin_basename( __FILE__ ) ) . '/langs/' ); 
		}

		/**
		* Activate plugin
		*/
		public static function activate(){} # END Function : activate

		/**
		* Deactivate plugin
		*/
		public static function deactivate(){} # END of function : deactivate

	} # END Class : easy_image_widget
} # END : if(!class_exits("easy_image_widget"))


if(class_exists("easy_image_widget")){

	# Installation and uninstallation Hooks
	register_activation_hook(__FILE__,array("easy_image_widget","activate"));
	register_deactivation_hook(__FILE__,array("easy_image_widget","deactivate"));

	# instantiate Plugin Class
	$easy_image_widget = new easy_image_widget();

} #END : if(class_exists("easy_image_widget"))
